#include <asm/unistd_32.h> 
#define PM 0x300
.data
msg:
.asciz "Hello world\n"
.set    len,.-msg-1
B:
.double 1.0
C:
.double 8.0
A:
.double 3.0
CW:
.long	0

fmtX:
.asciz "cw = %.8X\n"

fmt:
.asciz "res = %1.15lf\n"

.global main
.text
main: 
	// выполняем вычисления формулы A=1/(1/B+1/C), используя FPU
	fldl	B
	fld1
	fdivp	

	fldl	C
	fld1
	fdivp

	faddp

	fld1
	fdivp
	
	fstpl	A

	// выводим результат
	pushl	A+4
	pushl	A

	pushl	$fmt
	call	printf
	addl	$12,%esp

	// выводим на экран контрольное слово FPU
	fstcw	CW
	
	pushl CW
	pushl $fmtX
	call printf
	addl $8,%esp

	// зануляем 8 и 9 биты в контрольном слове
	// эти биты определяют режим точности FPU
	andl $(~PM), CW
	fldcw CW

	pushl CW
	pushl $fmtX
	call printf
	addl $8,%esp

	// снова производим те же самые вычисления и смотрим результат
	fldl	B
	fld1
	fdivp	

	fldl	C
	fld1
	fdivp

	faddp

	fld1
	fdivp
	
	fstpl	A

	pushl	A+4
	pushl	A

	pushl	$fmt
	call	printf
	addl	$12,%esp

        movl    $__NR_exit,%eax
        movl    $0,%ebx
        int     $0x80


